function y = ff_h_inv(x,info)

% Mapping from (A0tilde,A+tilde) to (Llambda0,Llambda+,w1,w2).  If (A0tilde,A+tilde) satisfies the zero
% restrictions, then ff_h_inv(ff_h(A0tilde,A+tilde)) = (A0tilde,A+tilde)


n              = info.n;
ninst          = info.k;
ntilde         = info.ntilde;
mtilde         = info.mtilde;
dim1           = info.dim1;
W1             = info.W1;
dim2           = info.dim2;
W2             = info.W2;



% structural to orthogonal-triangular-block parameterization
z        = f_h_inv(x,info);




ZF       = info.ZF(f_h([z(1:ntilde*(mtilde+ntilde)); vec(eye(n)); vec(eye(ninst))],info),info);
Qtilde1  = reshape(z(ntilde*(mtilde+ntilde)+1:ntilde*(mtilde+ntilde)+n*n),n,n);
Qtilde2  = reshape(z(ntilde*(mtilde+ntilde)+n*n+1:end),ninst,ninst);

w1=zeros(dim1,1);
k=0;
for j=1:n
    s=size(W1{j},1);
    Mj_tilde=[Qtilde1(:,1:j-1)'; ZF{j}*[eye(n);zeros(ninst,n)]; W1{j}];
    [K,R]=qr(Mj_tilde');    
    for i=n-s+1:n
        if (R(i,i) < 0) 
            K(:,i)=-K(:,i);
        end
    end 
    Kj=K(:,n-s+1:n);
    w1(k+1:k+s)=Kj'*Qtilde1(:,j);
    k=k+s;
end

w2=zeros(dim2,1);
k=0;
for j=1:ninst
    s=size(W2{j},1);
    Mj_tilde=[Qtilde2(:,1:j-1)'; W2{j}];
    [K,R]=qr(Mj_tilde');    
    for i=ninst-s+1:ninst
        if (R(i,i) < 0) 
            K(:,i)=-K(:,i);
        end
    end 
    Kj=K(:,ninst-s+1:ninst);
    w2(k+1:k+s)=Kj'*Qtilde2(:,j);
    k=k+s;
end


 y=[z(1:ntilde*(mtilde+ntilde)); w1;w2];

