%% ******
Draws_FEVDs_diff = nan(n,n,hmax+1,opt.Kdraws);

for draw = 1:opt.Kdraws
    
    para0 = reshape(B(:,draw),m,n);
    para  = [para0(end,:);para0(1:end-1,:)];
    
    A0_aer18 = inv2(SigmatrQ(:,:,draw)');
    
    IRFs_diff = getIRFs_diff(para,A0_aer18,opt.const,n,opt.p,hmax);
    Draws_FEVDs_diff(:,:,:,draw) = varianceDecompositionOfVAR(IRFs_diff,hmax);
    
end

%% Plot
for jj = 1:length(shockind)
    
    j = shockind(jj);
    
    figure
    set(gcf,'name',strcat('FEVD_diff:', shockname{j}))
    for i = 1:n
        
        subplot(ceil(n/2),2,i) 
        relevantIRFs = squeeze(Draws_FEVDs_diff(i,j,:,:));
        percentiles1 = prctile(relevantIRFs,bands,2);                   % Compute percentiles
        plot(x,percentiles1(:,2),'b','LineWidth',medianwidth)
        hold on
        [~,~]=jbfill(x,percentiles1(:,1)',percentiles1(:,3)',rgb('mediumblue'),rgb('mediumblue'),0,0.2);
        hold on
        plot(x,zeros(hmax+1,1),'--k')  % Plot the zero line
        title(varnames{i},'Fontsize',10)
        xlim([0 hmax])
    end
end
