rSinglePriorMean = mean(rSinglePriorPost,3);

% Compute posterior mean bounds.
meanlb = mean(rMinPost,3);
meanub = mean(rMaxPost,3);

% Compute robustified credible regions for IS.
opt.gridLength = 1000; % Size of grid used when computing credible intervals
opt.aalpha     = 0.68; % Credibility level for robust credible and HPD intervals
[credlb,credub] = credibleRegion(permute(rMinPost,[3,1,2]),permute(rMaxPost,[3,1,2]),opt);
% Compute highest posterior density (HPD) interval under single prior.
[hpdlb,hpdub] = highestPosteriorDensity(permute(rSinglePriorPost,[3,1,2]),opt);

postMeanBoundWidth = meanub - meanlb; % Width of posterior mean bounds.
hpdWidth = hpdub - hpdlb; % Width of highest posterior density regions
credWidth = credub - credlb; % Width of robustified credible region

priorInformativeness = 1 - hpdWidth./credWidth; % Informativeness of prior
figure
plot(priorInformativeness)
title('Informativeness of prior')

%% Plot IRs
plotx = 0:1:Hz-1;

for ii = 1:n
    
    figure;
    h1 = plot(plotx,meanlb(:,ii),'color','k','LineStyle','--');
    hold on;
    plot(plotx,meanub(:,ii),'color','k','LineStyle','--');
    h2 = plot(plotx,credlb(:,ii),'-k','LineWidth',2);
    plot(plotx,credub(:,ii),'-k','LineWidth',2);
    h3 = plot(plotx,rSinglePriorMean(:,ii),'ko','MarkerFaceColor','k');
    h4 = plot(plotx,hpdlb(:,ii),'--k','LineWidth',2);
    plot(plotx,hpdub(:,ii),'--k','LineWidth',2);
    for hh = 0:Hz-1
        line([hh hh],[meanlb(hh+1,ii) meanub(hh+1,ii)],'color','k');
    end
    line([0 Hz-1],[0 0],'color','black','LineStyle',':');
    
end