function v = GetNullVector(A0,k)
%
% Returns a non-zero vector x such that x is perpendicular to every column
% of A0 except for the kth.  Uses the LU decomposition of A0.  The vector
% is not normalized to have length one.
%
% The matrix A must n x n and invertiable with 1 <= k <= n.  This is not
% checked. 
%
 
e=zeros(size(A0,2),1);
e(k)=1.0;
v=A0'\e;
