ntilde          = n + k;               % VAR variables + proxies
n_lags          = 0;                   % number of lags in the VAR
nex             = 1;                   % 1 when constant is included
mtilde          = ntilde*n_lags + nex; % number of predetermined variables
horizons        = 0:0;                 % horizons of IRFs to impose sign restrictions, enters into get_dim_Ws_and_info.m
NS              = 1 + numel(horizons); % number of objects to restrict with proxy or additional zero restrictions, i.e. [\tilde{A}_{0};(\tilde{A}_{0})^{-1\prime}]
Hz              = 48;                  % horizon to compute IRFs

% SVAR Priors 
nu            = ntilde;                                          % degrees of freedom
Phi           = eye(ntilde^2)*1e-16;                             % Phi^-1: variance of \tilde{A}_0.
Psi           = zeros((n_lags*ntilde + nex)*ntilde,ntilde^2);    % Psi: mean of \tilde{A}_+
Omega_inv     = eye((n_lags*ntilde + nex)*ntilde)*1e-16;         % Omega: variance of \tilde{A}_+

% Prior for the Proposal
nu_bar        = ntilde;                                       % degrees of freedom
Phi_bar       = eye(ntilde^2)*1e-16;                          % Phi^-1:  variance of \tilde{A}_0.
Psi_bar       = zeros((n_lags*ntilde + nex)*ntilde,ntilde^2); % Psi_bar: mean of \tilde{A}_+
Omega_bar_inv = eye((n_lags*ntilde + nex)*ntilde)*1e-16;      % Omega:   variance of \tilde{A}_+

% Define Uj and Vj matrices. See Appendix A.4.
Uj = cell([ntilde,1]);
for i = 1:ntilde
    Uj{i} = eye([ntilde,i]); 
end
Vj = cell([ntilde,1]);
for i = 1:n
    Vj{i} = zeros(mtilde,mtilde-n_lags*k);
    for ell = 1:n_lags
        Vj{i}(1 + (ell-1)*ntilde:ell*ntilde,1 + (ell-1)*n:n + (ell-1)*n) = eye([ntilde,n]);
    end
    if nex > 0
        Vj{i}(mtilde-nex+1:mtilde,n_lags*n+1:n_lags*n+nex)= eye(nex);
    end
end
for i = n+1:ntilde
    Vj{i} = eye(mtilde);
end

% Store the dimensions of the rows of U and the columns of V. Input for get_dim_Ws_and_info.m
WW = cell([ntilde,1]);
for i=1:ntilde
     WW{i} = zeros(size(Vj{i},1),size(Uj{i},2));
end