% Draw Q_{1} and Q_{2} using Arias, Rubio-Ramirez and Waggoner(2018). Drawing these matrices requires some notation


% dim1 counts the dimension of the manifold defined over Q_{1} 
dim1=0;
for i=1:n
    dim1=dim1+n-(i-1+size(Z{i},1));
end

% dim2 counts the dimension of the manifold defined over Q_{2} 
dim2=0;
for i=1:k
    dim2=dim2+k-(i-1);
end

% gets a random W1 related to the applicability of Theorem 3. Appendix A3 in Inference Based on Sign and Zero Restrictions: Theory and Applications.
W1=cell(n,1);
for j=1:n
    W1{j}=randn(n-(j-1+size(Z{j},1)),n);
end

% gets a random W2 related to the applicability of Theorem 3. Appendix A3 in Inference Based on Sign and Zero Restrictions: Theory and Applications.
W2=cell(k,1);
for j=1:k
    W2{j}=randn(k-(j-1),k);
end

% Setup the structure "info". This is useful when computing the volume elements
info.n              = n;
info.k              = k;
info.mtilde         = ntilde*n_lags + nex;
info.W1             = W1;
info.W2             = W2;
info.ZF             = @(x,y)ZF(x,y);
info.ZFstructural   = @(x,y)ZFstructural(x,y);
info.horizons       = horizons;
info.ntilde         = ntilde;
info.n_lags         = n_lags;
info.Z              = Z;            % Only proxy restrictions F(\tilde{A}_0,\tilde{A}_+)=[\tilde{A}_{0};\tilde{L}_{0};...;\tilde{L}_{horizons}]
info.Zstructural    = Zstructural;  % All zero restrictions F(\tilde{A}_0,\tilde{A}_+)  =[\tilde{A}_{0};\tilde{L}_{0};\tilde{A}_{+}]
info.dim1           = dim1;
info.dim2           = dim2;
info.dim0           = 0;


for i=1:ntilde
    info.dim0 = size(Uj{i},2)+info.dim0;
end
for i=1:ntilde
    info.dim0 = size(Vj{i},2)+info.dim0;
end

