function [Sjtilde_inv,Pjtilde,Hj_inv,UT,TiUp] = SetupRestrictionsGaussianGeneralizedGaussian(Sj_inv, Pj, Hj_inv, U, V)
%
% nu and Phi: generalized gaussian parameters (nu is not used)
%
% Psi and Omega: matrix gaussian parameters
%
%    A0*e(j) = U{j}*b(j)
% 
%    Aplus*e(j) = V{j}*g(j) 
%
% T{j}*T{j}' = S{j}
%
% UT{j} = U{j}*T{j}       - used in simulation of A0
% TiUp = inv(T{j})*U{j}'  - used to compute restricted generalized gaussian kernel

ntilde  = size(Pj,1);


UT      = cell(ntilde,1);
TiUp    = cell(ntilde,1);


Hjtilde_inv  = cell(ntilde,1);
Pjtilde      = cell(ntilde,1);
Sjtilde_inv  = cell(ntilde,1);

for j=1:ntilde
  
    Hjtilde_inv{j} = V{j}'*Hj_inv{j}*V{j};
    
j
    Pjtilde{j}     = Hjtilde_inv{j}\(V{j}'*Hj_inv{j}*Pj{j}*U{j}); 
    
    Sjtilde_inv{j} = U{j}'*Sj_inv{j}*U{j} + U{j}'*Pj{j}'*Hj_inv{j}*Pj{j}*U{j} - Pjtilde{j}'*Hjtilde_inv{j}*Pjtilde{j};
    
    Ti             = chol(inv(Sjtilde_inv{j}))'; 

    UT{j}          = U{j}/Ti;
    
    TiUp{j}        = Ti*U{j}';

end

