function y = f_h_inv(x,info)

% mapping from vectorized structural parameters [A0tilde,A+tilde] to vectorized [A0hat,A+hat,Q]parameters.


% h_tilde() also uses info.h
n                = info.n;
k                = info.k;
ntilde           = info.ntilde;
mtilde   = info.mtilde;

A0tilde    = reshape(x(1:ntilde*ntilde),ntilde,ntilde);
Aplustilde = reshape(x(ntilde*ntilde+1:end),mtilde,ntilde);

[Q,R] = qr(inv(A0tilde));
for i=1:ntilde
    if R(i,i)<0
      Q(:,i)= -Q(:,i);
    end
end


Q1 = Q(1:n,1:n);
Q2 = Q(n+1:ntilde,n+1:ntilde);

Llambda0    = A0tilde*Q;
Llambdaplus = Aplustilde*Q;



y=[reshape(Llambda0,ntilde*ntilde,1); reshape(Llambdaplus,mtilde*ntilde,1); reshape(Q1',n*n,1); reshape(Q2',k*k,1)];
