clear 
clc
close all

addpath('functions')

%%
load('result_IV_Only.mat') % Replication code for IV-Only Approach

width_NoNarrative = nan(n,2,Hz);
for j = 1:length(targetshock)
    targetshockj = targetshock(j);
    for i = 1:n
        relevantIRFs = squeeze(Draws_IRFs(i,targetshockj,:,:));
        IRFband68    = prctile(relevantIRFs,bands68,2);
        width_NoNarrative(i,j,:) = IRFband68(:,2) - IRFband68(:,1);
    end
end

%%
load('result_inference.mat')

width_Narrative_inference = nan(n,2,Hz);
for j = 1:length(targetshock)
    targetshockj = targetshock(j);
    for i = 1:n
        relevantIRFs = squeeze(Draws_IRFs(i,targetshockj,:,:));
        IRFband68    = prctile(relevantIRFs,bands68,2);
        width_Narrative_inference(i,j,:) = IRFband68(:,2) - IRFband68(:,1);
    end
end

%% Informativeness of Narrative Sign Restrictions
info_N = nan(n,2,Hz);
for j = 1:2
    for i = 1:n
        for k = 1:Hz
            info_N(i,j,k) = 1-width_Narrative_inference(i,j,k)/width_NoNarrative(i,j,k);
        end
    end
end

%%
for j = 1:2
    figure
    for i = 1:n
        subplot(ceil(n/3),3,i)
        plot(plotx,squeeze(info_N(i,j,:)),'LineWidth',LineWidthp,'Color','b')
        title(varnames{i})
    end
end

%%
save result_Informativeness_N_inference width_NoNarrative width_Narrative_inference info_N