function [rmin,rmax,flag] = numericalBoundsPar(restrF,restrf,SStd,SSNs,Q0,Llambda0tilde,Llambdaplustilde,Hz,jshock,info)

k = info.k;
n = info.n;

% Set equality constraint for optimisation (Aeq*Q(:) = beq).
Aeq = zeros(k*(n-k),n^2);
beq = zeros(k*(n-k),1);
restrCount = 0;
for ii = 1:n % For each column of Q
    for jj = 1:restrf(ii) % For each restriction on ith column of Q
        restrCount = restrCount + 1;
        Aeq(restrCount,(ii-1)*n+1:ii*n) = restrF(restrCount,:);
    end
end

% Set inequality constraints for optimisation (Aineq*Q(:) <= b).
Aineq = [-SStd;-SSNs];
bineq = zeros(size(Aineq,1),1);

rmin  = zeros(Hz,n);
rmax  = rmin;
flagh = zeros(Hz,1);
LB = [];
UB = [];

parfor hh = 1:Hz % For each horizon
    [rmin_hh,rmax_hh,flaghh] = genBounds(Q0,jshock,Llambda0tilde,Llambdaplustilde,Aineq,bineq,Aeq,beq,LB,UB,hh,info);
    flagh(hh,1) = sum(sum(flaghh')>0)==2;
    if flagh(hh,1) == 1
        rmin_hh = rmin_hh(:,flaghh(1,:)>0);
        rmax_hh = -rmax_hh(:,flaghh(2,:)>0); % Max obtained by minimising negative of objective
        % Take optima over different initial values.
        rmin(hh,:)  = min(rmin_hh');
        rmax(hh,:)  = max(rmax_hh');
    end
 end

flag = sum(flagh) == length(flagh);

end

