function [y,Qtilde] = ff_h_A(x,info)
%
% Mapping from (Llambda_{0}, Llambda_{+}, W_{1},W_{2}) to (\tilde{A}_{0},\tilde{A}_{+}).  Llambda_{0} is supper-triangular and
%  Llambda_{+} is a block matrix, then (\tilde{A}_{0},\tilde{A}_{+}) will satisfy the zero restrictions and
% ff_h(ff_h_inv(Llambda_{0}, Llambda_{+}, W_{1},W_{2})) = (Llambda_{0}, Llambda_{+}, W_{1},W_{2})


n              = info.n;
ninst          = info.k;
ntilde         = info.ntilde;
mtilde         = info.mtilde;
dim1           = info.dim1;



% Llambda0    = reshape(x(1:ntilde*ntilde),ntilde,ntilde);
% Llambdaplus = reshape(x(ntilde*ntilde+1:(ntilde*ntilde+mtilde*ntilde)),mtilde,ntilde);
% Q = eye(ntilde);
% z=[reshape(Llambda0*Q,ntilde*ntilde,1); reshape(Llambdaplus*Q,mtilde*ntilde,1);];
z  = f_h([x(1:(mtilde+ntilde)*ntilde); vec(eye(n)); vec(eye(ninst))],info);


ZF=info.ZF(z,info);

W1=info.W1;
W2=info.W2;


w1=x((mtilde+ntilde)*ntilde+1:(mtilde+ntilde)*ntilde+dim1);


Qtilde1=zeros(n,n);
k=0;
for j=1:n
    s=size(W1{j},1);
    wj=w1(k+1:k+s);
    Mj_tilde=[Qtilde1(:,1:j-1)'; ZF{j}*[eye(n);zeros(ninst,n)];W1{j}];
    
    [K,R]=qr(Mj_tilde');    
    for i=n-s+1:n
        if (R(i,i) < 0) 
            K(:,i)=-K(:,i);
        end
    end 
    Kj=K(:,n-s+1:n);
    Qtilde1(:,j)=Kj*wj;
    k=k+s;
end

w2=x((mtilde+ntilde)*ntilde+dim1+1:end);
Qtilde2=zeros(ninst,ninst);
k=0;
for j=1:ninst
    s=size(W2{j},1);
    wj=w2(k+1:k+s);

    Mj_tilde=[Qtilde2(:,1:j-1)'; W2{j}];
    
    [K,R]=qr(Mj_tilde');    
    for i=ninst-s+1:ninst
        if (R(i,i) < 0) 
            K(:,i)=-K(:,i);
        end
    end 
    Kj=K(:,ninst-s+1:ninst);
    Qtilde2(:,j)=Kj*wj;
    k=k+s;
end

Qtilde = [Qtilde1, zeros(n,ninst);
     zeros(ninst,n), Qtilde2];

 %keyboard

A0    = reshape(z(1:ntilde*ntilde),ntilde,ntilde);
Aplus = reshape(z(ntilde*ntilde+1:end),mtilde,ntilde);


y=[vec(A0*Qtilde); vec(Aplus*Qtilde)];


