function [rmin,rmax,flags] = genBounds(Q0,jshock,Llambda0tilde,Llambdaplustilde,Aineq,bineq,Aeq,beq,LB,UB,hh,info)

optimOptions.Display = 'off'; % Do not display optimisation output
% Provide analytical gradient of nonlinear constraint.
optimOptions.SpecifyConstraintGradient = true; 
optimOptions.CheckGradients = false; % Check provided gradients numerically

n = info.n;

rmin  = zeros(n,size(Q0,3));
rmax  = rmin;
flags = nan(2,size(Q0,3));

for kk = 1:size(Q0,3) % For each initial value of Q
    QInit = Q0(1:n,1:n,kk);
    QInit = QInit(:); % Vectorise initial value of Q
    for ii = 1:n % For each variable of interest
        % Minimise IRF subject to sign and equality restrictions.
        [~,rmin(ii,kk),flags(1,kk)] = fmincon(@(Q) genIRF(Q,jshock,Llambda0tilde,Llambdaplustilde, ...
                                                 ii,hh,1,info),QInit,Aineq,bineq,Aeq,beq,LB,UB, ...
                                                 @(Q) Qcon(Q,n),optimOptions);
        % Maximise IRF subject to sign and equality restrictions.
        [~,rmax(ii,kk),flags(2,kk)] = fmincon(@(Q) genIRF(Q,jshock,Llambda0tilde,Llambdaplustilde, ...
                                                 ii,hh,-1,info),QInit,Aineq,bineq,Aeq,beq,LB,UB, ...
                                                 @(Q) Qcon(Q,n),optimOptions);
    end
end

