clear
clc
close all

addpath('functions'); % set path to helper functions
addpath('matlab_720_v3')

load('result2.mat')

%% news shock
rMinPost = rMinPost1;
rMaxPost = rMaxPost1;

% Compute widths of the set of posterior means
spmWidth_news = mean(rMaxPost,3) - mean(rMinPost,3); 

%% tfp shock
rMinPost = rMinPost2;
rMaxPost = rMaxPost2;

% Compute widths of the set of posterior means
spmWidth_tfp = mean(rMaxPost,3) - mean(rMinPost,3);

%%
names  = {'gdp','con','inv','emp','NYSE','Productivity'};
figname = cell(n,1);
for i = 1:n
    figname(i) = strcat(names{i},{'ToNewsSPM'});
end
for i = 1:n
    figure
    plot(spmWidth_news(:,i),'k-','LineWidth',3)
    axis tight;
    set(gca,'FontSize',24);
    cd Figure
    print('-depsc',figname{i})
    cd ..
end
close all

%% tfp shock
figname = cell(n,1);
for i = 1:n
    figname(i) = strcat(names{i},{'ToTFPSPM'});
end
for i = 1:n
    figure
    plot(spmWidth_tfp(:,i),'k-','LineWidth',3)
    axis tight;
    set(gca,'FontSize',24);
    cd Figure
    print('-depsc',figname{i})
    cd ..
end
close all

