clear 
clc
close all

addpath('functions')

%%
load('result2.mat')

LineWidthp  = 3;

width_Narrative = nan(n,2,Hz);

rMinPost = rMinPost1;
rMaxPost = rMaxPost1;
width_Narrative(:,1,:) = (mean(rMaxPost,3) - mean(rMinPost,3))'; 

rMinPost = rMinPost2;
rMaxPost = rMaxPost2;
width_Narrative(:,2,:) = (mean(rMaxPost,3) - mean(rMinPost,3))';

%%
load('result_Nonarrative_Counterfactual.mat')
width_NoNarrative_Counterfactual = nan(n,2,Hz);

rMinPost = rMinPost1;
rMaxPost = rMaxPost1;
width_NoNarrative_Counterfactual(:,1,:) = (mean(rMaxPost,3) - mean(rMinPost,3))'; 

rMinPost = rMinPost2;
rMaxPost = rMaxPost2;
width_NoNarrative_Counterfactual(:,2,:) = (mean(rMaxPost,3) - mean(rMinPost,3))';

load('result_Nonarrative.mat')
width_NoNarrative = nan(n,2,Hz);

rMinPost = rMinPost1;
rMaxPost = rMaxPost1;
width_NoNarrative(:,1,:) = (mean(rMaxPost,3) - mean(rMinPost,3))'; 

rMinPost = rMinPost2;
rMaxPost = rMaxPost2;
width_NoNarrative(:,2,:) = (mean(rMaxPost,3) - mean(rMinPost,3))';

%% Informativeness of Narrative Sign Restrictions: identification
info_N = nan(n,2,Hz);
for j = 1:2
    for i = 1:n
        for k = 1:Hz
            info_N(i,j,k) = 1-width_Narrative(i,j,k)/width_NoNarrative_Counterfactual(i,j,k);
        end
    end
end

for j = 1:2
    figure
    for i = 1:n
        subplot(ceil(n/3),3,i)
        plot(plotx,squeeze(info_N(i,j,:)),'LineWidth',LineWidthp,'Color','b')
        title(varnames{i})
    end
end

%% Informativeness of Narrative Sign Restrictions: inference
info_N = nan(n,2,Hz);
for j = 1:2
    for i = 1:n
        for k = 1:Hz
            info_N(i,j,k) = 1-width_NoNarrative_Counterfactual(i,j,k)/width_NoNarrative(i,j,k);
        end
    end
end

for j = 1:2
    figure
    for i = 1:n
        subplot(ceil(n/3),3,i)
        plot(plotx,squeeze(info_N(i,j,:)),'LineWidth',LineWidthp,'Color','b')
        title(varnames{i})
    end
end

%% Informativeness of Narrative Sign Restrictions 
info_N = nan(n,2,Hz);
for j = 1:2
    for i = 1:n
        for k = 1:Hz
            info_N(i,j,k) = 1-width_Narrative(i,j,k)/width_NoNarrative(i,j,k);
        end
    end
end

for j = 1:2
    figure
    for i = 1:n
        subplot(ceil(n/3),3,i)
        plot(plotx,squeeze(info_N(i,j,:)),'LineWidth',LineWidthp,'Color','b')
        title(varnames{i})
    end
end


%%
save result_Informativeness_N width_NoNarrative width_Narrative info_N