clear 
clc
close all

addpath('functions')

%%
load('result2.mat')

LineWidthp  = 3;

width_Narrative = nan(n,2,Hz);

rMinPost = rMinPost1;
rMaxPost = rMaxPost1;
width_Narrative(:,1,:) = (mean(rMaxPost,3) - mean(rMinPost,3))'; 

rMinPost = rMinPost2;
rMaxPost = rMaxPost2;
width_Narrative(:,2,:) = (mean(rMaxPost,3) - mean(rMinPost,3))';

%%
load('result_Nonarrative_Counterfactual.mat')
width_NoNarrative_Counterfactual = nan(n,2,Hz);

rMinPost = rMinPost1;
rMaxPost = rMaxPost1;
width_NoNarrative_Counterfactual(:,1,:) = (mean(rMaxPost,3) - mean(rMinPost,3))'; 

rMinPost = rMinPost2;
rMaxPost = rMaxPost2;
width_NoNarrative_Counterfactual(:,2,:) = (mean(rMaxPost,3) - mean(rMinPost,3))';

load('result_Nonarrative.mat')
width_NoNarrative = nan(n,2,Hz);

rMinPost = rMinPost1;
rMaxPost = rMaxPost1;
width_NoNarrative(:,1,:) = (mean(rMaxPost,3) - mean(rMinPost,3))'; 

rMinPost = rMinPost2;
rMaxPost = rMaxPost2;
width_NoNarrative(:,2,:) = (mean(rMaxPost,3) - mean(rMinPost,3))';

%% Informativeness of Narrative Sign Restrictions: identification
info_N = nan(n,2,Hz);
for j = 1:2
    for i = 1:n
        for k = 1:Hz
            info_N(i,j,k) = 1-width_Narrative(i,j,k)/width_NoNarrative_Counterfactual(i,j,k);
        end
    end
end

for j = 1:2
    figure
    for i = 1:n
        subplot(ceil(n/3),3,i)
        plot(plotx,squeeze(info_N(i,j,:)),'LineWidth',LineWidthp,'Color','b')
        title(varnames{i})
    end
end

%%
varnames  = {'gdp','con','inv','emp','NYSE','Productivity'};
shockname = {'news','tfp'};
filename  = 'Figure/Identification';

irfw = 70*3.5;
irfh = 70*3;
LineWidthp = 3;
n  = size(info_N,1);
Hz = size(info_N,3);
plotx = 0:1:Hz-1;

for j = 1:2
    for i = 1:n
        filename1 = [filename,varnames{i},'to',shockname{j}];     
        figure  
        set(gcf, 'Position', [0, 200, irfw, irfh])        
        axes('FontSize', 16, 'NextPlot', 'add');
        plot(plotx,squeeze(info_N(i,j,:)),'LineWidth',LineWidthp,'Color','b')
        % hold on
        % plot(plotx,zeros(Hz,1),'LineWidth',1,'Color',[0.5 0.5 0.5]);
        axis tight;
        ylim([0.5 1])
        print('-depsc',filename1);
	    print('-dpng',filename1);
    end
end

result = nan(n,2,3);
for j = 1:2
    for i = 1:n
        if i == 1
            result(i,j,1) = mean(squeeze(info_N(n,j,:)));
            result(i,j,2) = min(squeeze(info_N(n,j,:)));
            result(i,j,3) = max(squeeze(info_N(n,j,:)));
        else
            result(i,j,1) = mean(squeeze(info_N(i-1,j,:)));
            result(i,j,2) = min(squeeze(info_N(i-1,j,:)));
            result(i,j,3) = max(squeeze(info_N(i-1,j,:)));
        end
    end
end

numString = [];
for ii = 1:5
    numString = [numString '%8.2f & '];
end
numString = [numString '%8.2f'];

cname = {'Average & ','Minimum & ','Maximum & '};
    
FID = fopen('table/Table.tex','w');
for j = 1:2
    for ri = 1:3
        fprintf(FID,strcat('%s',numString,'  \\\\  \n'),cname{ri},squeeze(result(:,j,ri)));
    end
end