function y = IRFRestrictions(z,info)
%
%  Z - n x 1 cell of z_j x k matrices
%  f(x) - stacked A0 and impulse responses
%  
%  restrictions:
%
%     Z{j}*f(x)*e_j = 0
%

n_lags = info.n_lags;
n      = info.n;
ntilde = info.ntilde;
n2 = ntilde*ntilde;

f  = nan((n_lags+1)*ntilde+1,ntilde);
for i = 1:n_lags+1
    f(1+(i-1)*ntilde:i*ntilde,:) = reshape(z(1+(i-1)*n2:n2*i),ntilde,ntilde);
end
f(end,:) = z((n_lags+1)*n2+1:end);

Zirf = cell(ntilde,1);
for i = 1:ntilde
    Zirf{i} = zeros(0,(n_lags+1)*ntilde+1);
end

% instruments
for i = 1:ntilde
  Zirf{i}  = [info.Z{i}(:,ntilde+1:end) zeros(size(info.Z{i},1),n_lags*ntilde+1)];
end
    
for i = n+1:ntilde
    ind = 1;
    for ii = 1:n_lags+1
        for iii = 1:n
            Zirf{i}(ind,iii+(ii-1)*ntilde) = 1;
            ind = ind+1;
        end
    end
end
            
total_zeros = 0;
for j = 1:ntilde
    total_zeros = total_zeros+size(Zirf{j},1);
end

y = zeros(total_zeros,1);
ib = 1;
for j = 1:ntilde
    ie = ib+size(Zirf{j},1);  
    y(ib:ie-1) = Zirf{j}*f(:,j);
    ib = ie;
end