function [Ns,Nc] = get_Narrative_Restrictions(NSR,varNames,dates,shockNames)

Ttilde = length(dates);
ntilde = length(varNames);

% Narrative Sign Restrictions

Ns = zeros(Ttilde,ntilde);
Nc = zeros(Ttilde,Ttilde,ntilde,ntilde);

%% Set up Narrative Sign Restrictions

for rest = 1:size(NSR,2)
    
    switch NSR{rest}{2}
        case 'sign of shock'
            Ns(ismember(dates,NSR{rest}{3}),strcmp(shockNames,NSR{rest}{1})) = NSR{rest}{4};
        case 'contribution'
            switch NSR{rest}{7}
                case 'strong'
                    if sign(NSR{rest}{6})==1
                        Nc(ismember(dates,NSR{rest}{3}),ismember(dates,NSR{rest}{4}),strcmp(shockNames,NSR{rest}{1}),strcmp(varNames,NSR{rest}{5})) = 2;
                    else
                        Nc(ismember(dates,NSR{rest}{3}),ismember(dates,NSR{rest}{4}),strcmp(shockNames,NSR{rest}{1}),strcmp(varNames,NSR{rest}{5})) = -1;
                    end
                case 'weak'
                    if sign(NSR{rest}{6})==1
                       Nc(ismember(dates,NSR{rest}{3}),ismember(dates,NSR{rest}{4}),strcmp(shockNames,NSR{rest}{1}),strcmp(varNames,NSR{rest}{5})) = 1;
                    else
                       Nc(ismember(dates,NSR{rest}{3}),ismember(dates,NSR{rest}{4}),strcmp(shockNames,NSR{rest}{1}),strcmp(varNames,NSR{rest}{5})) = -2;                        
                    end
            end
    end
end

end
