% JOINTABSOLUTE.M
% 
% Bayes estimate and joint credible set for any M x nirf matrix IRF, where 
% M is the number of posterior draws and nirf is the number of impulse 
% responses. 

function [irfabs,credibleset]=jointabsolute(IRF)

M=size(IRF,1);
absolute_loss = zeros(M,1);
for i=1:M
   for j=1:M
       absolute_loss(i,1) = absolute_loss(i,1)+sum(abs(IRF(j,:)-IRF(i,:)));
   end
end
[~,Imin]=min(absolute_loss);
irfabs = IRF(Imin,:);
[a,I] = sort(absolute_loss);
credibleset = IRF(I(1:floor(0.68*M)+1),:);
