clear all
clc
close all

addpath('functions'); % set path to helper functions
addpath('matlab_720_v3')

load('result_N.mat')

[ntilde,~,numDesireddraws] = size(A0tilde);
k = 2;
n = ntilde - k;
n_lags = (size(Aplustilde,1)-1)/ntilde;
Hz      = 48;    
factor  = 50;
Draws_IRFs   = nan(ntilde,ntilde,Hz,numDesireddraws/factor);

parfor i = 1:numDesireddraws/factor
    
    if mod(i,1000) == 0
        disp(i)
    end
    
    CT = [inv(A0tilde(:,:,i*factor))'*Aplustilde(1:end-1,:,i*factor)';eye((n_lags-1)*ntilde,n_lags*ntilde)];
    AT = [inv(A0tilde(:,:,i*factor))';zeros(ntilde*n_lags-ntilde,ntilde)];   
    
    IRFs = nan(ntilde,ntilde,Hz);
    for h = 1:Hz
        irf = (CT^(h-1))*AT;
        IRFs(:,:,h) = irf(1:ntilde,:);
    end
    
    Draws_IRFs(:,:,:,i)  = IRFs;
           
end

%%
varnames  = {'gdp','con','inv','emp','NYSE','Productivity'};

shockname={'news','tfp'};

irfw=70*3.5;
irfh=70*3;
filename='Uniformmarginal/IRF';


targetshock = [n-1;n];
LineWidthp  = 3;
bands68 = [16,84];
bands90 = [5,95];
plotx   = 0:1:Hz-1;
for j = 1:length(targetshock)
    targetshockj = targetshock(j);
  %  figure
    for i = 1:n
  filename1=[filename,varnames{i},'to',shockname{j}]     
      %  subplot(ceil(n/2),2,i) 
      figure  
       set(gcf, 'Position', [0, 200, irfw, irfh])        
        axes('FontSize', 16, 'NextPlot', 'add');
        
   %      subplot(ceil(n/3),3,i)
        relevantIRFs = squeeze(Draws_IRFs(i,targetshockj,:,:));
        medianIRF    = prctile(relevantIRFs,50,2);
        IRFband68    = prctile(relevantIRFs,bands68,2);
  %      IRFband90    = prctile(relevantIRFs,bands90,2);
        plot(plotx,medianIRF,'LineWidth',LineWidthp,'Color','b')
        hold on
        [~,~]=jbfill(plotx,IRFband68(:,1)',IRFband68(:,2)',rgb('mediumblue'),rgb('mediumblue'),0,0.3);
   %     hold on
    %    [~,~]=jbfill(plotx,IRFband90(:,1)',IRFband90(:,2)',rgb('mediumblue'),rgb('mediumblue'),0,0.1);
        hold on
        plot(plotx,zeros(Hz,1),'LineWidth',1,'Color',[0.5 0.5 0.5]);
        axis tight;
%        title(varnames{i})
        print('-depsc',filename1);
	print('-dpng',filename1);
    end
end

%%
numDesireddraws = numDesireddraws/factor;
IRFs = nan(numDesireddraws,Hz*n*2);
count = 0;
for i = 1:n
    for j = n-1:n
        for h = 1:Hz
            count = count+1;
            IRFs(:,count) = squeeze(Draws_IRFs(i,j,h,:));
        end
    end
end

%%
absolute_loss = zeros(numDesireddraws,1);
parfor i = 1:numDesireddraws
    if mod(i,10) == 0
        disp(i)
    end
    for j = 1:numDesireddraws
        absolute_loss(i,1) = absolute_loss(i,1)+sum(abs(IRFs(j,:)-IRFs(i,:)));
    end
end

[~,Imin] = min(absolute_loss);
irfabs = IRFs(Imin,:);
[a,I] = sort(absolute_loss);
credibleset = IRFs(I(1:floor(0.68*numDesireddraws)+1),:);
            
IRFs_abs = nan(n,n,Hz);
IRFs_credibleset = nan(n,n,Hz,size(credibleset,1));
count = 0;
for i = 1:n
    for j = n-1:n
        for h = 1:Hz
            count = count+1;
            IRFs_abs(i,j,h) = irfabs(count);
            IRFs_credibleset(i,j,h,:) = credibleset(:,count);
        end
    end
end           
    
%%
targetshock = [n-1;n];
LineWidthp  = 3;
filename='Uniformjoint/IRF';
plotx   = 0:1:Hz-1;
for j = 1:length(targetshock)
    targetshockj = targetshock(j);
  %  figure
    for i = 1:n
   %     subplot(ceil(n/3),3,i)
     filename1=[filename,varnames{i},'to',shockname{j}]     
      %  subplot(ceil(n/2),2,i) 
      figure  
       set(gcf, 'Position', [0, 200, irfw, irfh])        
        axes('FontSize', 16, 'NextPlot', 'add');
        
        plot(plotx,zeros(Hz,1),'LineWidth',1,'Color',[0.5 0.5 0.5]);
        for ii = 1:size(credibleset,1)
            hold on
            plot(plotx,squeeze(IRFs_credibleset(i,targetshockj,:,ii)),'LineWidth',0.5,'Color','b')
        end
        hold on
        relevantIRFs = squeeze(IRFs_abs(i,targetshockj,:));
        plot(plotx,relevantIRFs,'LineWidth',LineWidthp,'Color','r')
        axis tight;
  %      title(varnames{i})
          print('-depsc',filename1);
	print('-dpng',filename1);
    end
end
    
save main_nu_Phi_Omega_N_joint_inference_100 IRFs_credibleset IRFs_abs  n Hz IRFs_credibleset plotx credibleset Draws_IRFs
